#!/bin/sh
# Shell script to install cron
InstallDIR=`dirname $0`
CronTAR=cron.tar.gz
#DLDHost=zephyr
#DLDLink=http://$DLDHost/dld
CronHome=/home/cron/Files
echo "Starting cron installation and configuration"
if [ -z `wv get [Groups]cron` ]; then
	wv set [Groups]cron = cron
	wv set [Full Names]cron = Team for cron
	echo -n "Waiting for the creation of team \"cron\". "
	while [ ! -d /home/cron ] ; do 
		sleep 2
		echo -n ". "
	done
	else echo "The Team \"cron\" already exists";
	ps -C cron --no-heading 1>/dev/null; result=$?
	if [ ${result} -eq 0 ]; then 
	echo "Stopping the current cron process"
	killall cron; fi
fi
if [ ! -f /CronHome/`basename $0` ]; then cp $0 $CronHome; fi
# Download and install cron package
#if [ ! -f $InstallDIR/cron ]; then
#	if [ ! -f $InstallDIR/$CronTAR ]; then
#		echo "Cron package does not exist downloading"
#		cd $CronHome
#		echo 'Checking for inernet connection'
#		ping -c 1 $DLDHost 1>/dev/null 2>/dev/null
#		if [ $? = 1 ]; then 
#			echo "No Internet Connection Exiting"
#			exit
#		fi
#		wget $DLDLink/$CronTAR # Nitix DLD link needs to be added.
#	else 
#		echo "Install package exists moving to $CronHome"
#		mv $InstallDIR/$CronTAR $CronHome
#		cd $CronHome
#	fi
#	tar -zxf $CronTAR
#else 
	echo "Installing new cron binary"
	cp $InstallDIR/cron $CronHome;
	cd $CronHome
#fi
# Set correct permissions and owner
chown _root:_root $CronHome/cron
chmod 555 $CronHome/cron
# Create init file and add configure so cron starts on boot.
if [ ! -d /bootdisk/etc ]; then mkdir /bootdisk/etc; ls /bootdisk/etc ; fi
if [ ! -f /bootdisk/etc/rclocal ]; then 
echo '#!/bin/sh' > /bootdisk/etc/rclocal; fi
grep -q "$CronHome/cron" /bootdisk/etc/rclocal; result=$?
if [ ${result} -eq 1 ]; then 
	echo "$CronHome/cron" >> /bootdisk/etc/rclocal; 
fi
# Configure cron
if [ ! -f $CronHome/crontab ]; then touch $CronHome/crontab; fi
if [ ! -d $CronHome/crontabs ]; then mkdir  $CronHome/crontabs; fi
if [ ! -f $CronHome/crontabs/_root ]; then
	touch  $CronHome/crontabs/_root
	chmod 600 $CronHome/crontabs/_root
fi
for i in `find /$CronHome/crontabs/ -type f -name "*~"`; do rm $i; done
# Cron will appear not to work if permissions are not 600 and user is not the same as filename
for i in `ls -1 $CronHome/crontabs/`; do chown $i $CronHome/crontabs/$i; chmod 600 $CronHome/crontabs/$i; done
# This manually starts cron
$CronHome/cron
ps -C cron --no-heading 1>/dev/null; result=$?
# This ensures that cron is running
if [ ${result} -eq 0 ]; then 
	echo "cron has been setup, and is available for use"
	echo "Edit the _root file located in $CronHome/crontabs/ to setup any jobs"
else
	echo "There was an error starting cron, check the log file located in $CronHome for the reason."
fi
# Done
